SystemOrganization addCategory: #Deprecated14!

ImageMorph subclass: #LogoImageMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

LogoImageMorph class
	instanceVariableNames: 'default'!

!LogoImageMorph commentStamp: 'AlainPlantec 9/11/2011 08:04' prior: 0!
Deprecated in 1.4 since we have a setting for the logo
!

LogoImageMorph class
	instanceVariableNames: 'default'!

!LogoImageMorph class methodsFor: 'defaultinstance' stamp: 'AlainPlantec 9/11/2011 08:33'!
default
	^default! !

!LogoImageMorph class methodsFor: 'defaultinstance' stamp: 'AlainPlantec 4/13/2010 13:34'!
default: newImageMorph
	default ifNotNil: [default delete].
	default := newImageMorph.
	default  ifNotNil: [
		default 
			openInWorld;
			beSticky;
			lock;
			goBehind]! !

!LogoImageMorph class methodsFor: 'defaultinstance' stamp: 'AlainPlantec 4/13/2010 13:01'!
defaultLogoForm
	^ Form fromBinaryStream: self defaultLogoContents base64Decoded asByteArray readStream! !

!LogoImageMorph class methodsFor: 'defaultinstance' stamp: 'AlainPlantec 9/11/2011 08:33'!
initialize
	default 
		ifNotNil: [self installDesktopLogo]! !

!LogoImageMorph class methodsFor: 'defaultinstance' stamp: 'AlainPlantec 9/11/2011 08:32'!
installDesktopLogo
	"Install the new logo with the settings"
	"self installDesktopLogo"
	default 
		ifNotNil: [default delete. 
		default := nil.
		PolymorphSystemSettings showDesktopLogo: true]
! !

MessageSet subclass: #ChangedMessageSet
	instanceVariableNames: 'changeSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!ChangedMessageSet commentStamp: 'BernardoContreras 8/1/2011 19:50' prior: 0!
DEPRECATED. see http://code.google.com/p/pharo/issues/detail?id=4574
A ChangedMessageSet is a message set associated with a change-set; it bears an entry for every method added or changed in the change set, as well as for every class-comment of which the change-set bears a note.!

!ChangedMessageSet class methodsFor: 'as yet unclassified' stamp: 'BernardoContreras 8/1/2011 19:53'!
openFor: aChangeSet
	"Open up a ChangedMessageSet browser on the given change set; this is a conventional message-list browser whose message-list consists of all the methods in aChangeSet.  After any method submission, the message list is refigured, making it plausibly dynamic"

	| messageSet |
	
	self deprecated: 'issue 4574' on: '1 August, 2011' in: 'Pharo1.4'.
	messageSet := aChangeSet changedMessageList select: [ :each | each isValid].
	self 
		openMessageList: messageSet 
		name: 'Methods in Change Set ', aChangeSet name
		autoSelect: nil
		changeSet: aChangeSet! !

!ChangedMessageSet class methodsFor: 'as yet unclassified' stamp: 'BernardoContreras 8/1/2011 19:53'!
openMessageList: messageList name: labelString autoSelect: autoSelectString changeSet: aChangeSet
	| messageSet |

	self deprecated: 'issue 4574' on: '1 August, 2011' in: 'Pharo1.4'.
	messageSet := self messageList: messageList.
	messageSet changeSet: aChangeSet.
	messageSet autoSelectString: autoSelectString.
	self openAsMorph: messageSet name: labelString! !

!ChangedMessageSet class methodsFor: 'tools registry' stamp: 'BernardoContreras 8/1/2011 19:54'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	self deprecated: 'issue 4574' on: '1 August, 2011' in: 'Pharo1.4'.
	registry register: self as: #changedMessageSet
! !

!ChangedMessageSet methodsFor: 'initialization' stamp: 'sd 11/20/2005 21:26'!
changeSet: aChangeSet
	changeSet := aChangeSet! !

!ChangedMessageSet methodsFor: 'acceptance' stamp: 'md 2/20/2006 18:42'!
contents: aString notifying: aController
	"Accept the string as new source for the current method, and make certain the annotation pane gets invalidated"

	| existingSelector existingClass superResult newSelector |
	existingSelector := self selectedMessageName.
	existingClass := self selectedClassOrMetaClass.

	superResult := super contents: aString notifying: aController.
	superResult ifTrue:  "succeeded"
		[newSelector := existingClass parserClass new parseSelector: aString.
		newSelector ~= existingSelector
			ifTrue:   "Selector changed -- maybe an addition"
				[self reformulateList.
				self changed: #messageList.
				self messageList doWithIndex:
					[:aMethodReference :anIndex |
						(aMethodReference actualClass == existingClass and:
									[aMethodReference methodSymbol == newSelector])
							ifTrue:
								[self messageListIndex: anIndex]]]].
	^ superResult! !

!ChangedMessageSet methodsFor: 'message list' stamp: 'sw 1/28/2001 20:59'!
growable
	"Answer whether the receiver can be changed by manual additions & deletions"

	^ false! !

!ChangedMessageSet methodsFor: 'reformulation' stamp: 'StephaneDucasse 1/7/2011 17:42'!
reformulateList
	"Reformulate the message list of the receiver"

	self initializeMessageList: 
		(changeSet changedMessageList select: [:each | each isValid])
! !

MessageSet subclass: #MessageNames
	instanceVariableNames: 'searchString selectorList selectorListIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!MessageNames commentStamp: 'BernardoContreras 8/14/2011 00:52' prior: 0!
DEPRECATED. see http://code.google.com/p/pharo/issues/detail?id=4576.!

!MessageNames class methodsFor: 'instance creation' stamp: 'BernardoContreras 8/14/2011 00:47'!
methodBrowserSearchingFor: searchString
	"Answer an method-browser window whose search-string is initially as indicated"

	| aWindow |
	self deprecated: 'issue 4576' on: '14 August, 2011' in: 'Pharo1.4'.
	aWindow := self new inMorphicWindowWithInitialSearchString: searchString.
	aWindow applyModelExtent.
	^ aWindow! !

!MessageNames class methodsFor: 'instance creation' stamp: 'BernardoContreras 8/14/2011 00:48'!
openMessageNames
	"Open a new instance of the receiver in the active world"

	self deprecated: 'issue 4576' on: '14 August, 2011' in: 'Pharo1.4'.	
	self new openAsMorphNamed: 'Message Names' inWorld: self currentWorld

	"MessageNames openMessageNames"
! !

!MessageNames class methodsFor: 'window color' stamp: 'AlainPlantec 12/16/2009 22:09'!
patchworkUIThemeColor
	"Answer a default color for UI themes that make use of different colors for Browser, MessageList etc..."

	^ Color fromRgbTriplet: #(0.645 1.0 0.452) ! !

!MessageNames class methodsFor: 'tools registry' stamp: 'IgorStasenko 2/19/2011 03:02'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 

	registry register: self as: #messageNames
! !

!MessageNames methodsFor: 'search' stamp: 'LucFabresse 10/1/2010 16:08'!
computeSelectorListFromSearchString
	"Compute selector list from search string"
	
	self searchString: (searchString asString copyWithout: Character arrowUp).
	selectorList := Cursor wait showWhile: [
					(SystemNavigation default allImplementedMessages select: [:each | each  includesSubstring: searchString caseSensitive: false]) asArray sort: [:x :y | x asLowercase <= y asLowercase]].
	^ selectorList! !

!MessageNames methodsFor: 'message list menu' stamp: 'sd 11/20/2005 21:27'!
copyName
	"Copy the current selector to the clipboard"

	| selector |
	(selector := self selectorList at: selectorListIndex ifAbsent: [nil]) ifNotNil:
		[Clipboard clipboardText: selector asString asText]! !

!MessageNames methodsFor: 'search' stamp: 'GaryChambers 7/5/2010 13:28'!
doSearchFrom: aTextMorph
	"The user hit the Search button -- treat it as a synonym for the user having hit the Return or Enter (or cmd-s) in the type-in pane"

	aTextMorph
		accept;
		changed! !

!MessageNames methodsFor: 'initialization' stamp: 'sw 7/28/2001 02:16'!
inMorphicWindowLabeled: labelString
	"Answer a morphic window with the given label that can display the receiver"
"MessageNames openMessageNames"

	^ self inMorphicWindowWithInitialSearchString: nil! !

!MessageNames methodsFor: 'initialization' stamp: 'JuanVuletich 10/22/2010 09:13'!
inMorphicWindowWithInitialSearchString: initialString
	"Answer a morphic window with the given initial search string, nil if none"

"MessageNames openMessageNames"

	^UIManager default messageNames: self inMorphicWindowWithInitialSearchString: initialString! !

!MessageNames methodsFor: 'selector list' stamp: 'StephaneDucasse 5/28/2011 13:34'!
messageList
	"Answer the receiver's message list, computing it if necessary. The way 
	to force a recomputation is to set the messageList to nil"
	messageList
		ifNil: [messageList := selectorListIndex = 0
						ifTrue: [#()]
						ifFalse: [self systemNavigation
								allImplementorsOf: (selectorList at: selectorListIndex)].
			self
				messageListIndex: (messageList size > 0
						ifTrue: [1]
						ifFalse: [0])].
	^ messageList! !

!MessageNames methodsFor: 'search' stamp: 'GaryChambers 7/5/2010 12:57'!
searchString
	"Answer the current searchString, initializing it if need be"

	^ searchString ifNil: [searchString := '']! !

!MessageNames methodsFor: 'accessing' stamp: 'LucFabresse 10/1/2010 15:56'!
searchString: aStringToSearch
	searchString := aStringToSearch! !

!MessageNames methodsFor: 'search' stamp: 'JuanVuletich 10/22/2010 10:12'!
searchString: aString from: aTextMorph
	"Take what the user typed and find all selectors containing it"

	aTextMorph selectAll.
	searchString := aString asString copyWithout: $ .
	self containingWindow ifNotNil: [ :w | w setLabel: ('Message names containing "{1}"' translated format: {searchString asLowercase}) ].
	selectorList := nil.
	self changed: #selectorList.
	self changed: #messageList.
	^true! !

!MessageNames methodsFor: 'selection' stamp: 'MarcusDenker 8/15/2010 10:57'!
selectedMessageName
	^selectorListIndex = 0 ifFalse: [selectorList at: selectorListIndex]! !

!MessageNames methodsFor: 'selection' stamp: 'sw 7/24/2001 01:46'!
selection
	"Answer the item in the list that is currently selected, or nil if no selection is present"

	^ self messageList at: messageListIndex ifAbsent: [nil]! !

!MessageNames methodsFor: 'selector list' stamp: 'sd 11/20/2005 21:27'!
selectorList
	"Answer the selectorList"

	selectorList ifNil:
		[self computeSelectorListFromSearchString.
		selectorListIndex :=  selectorList size > 0
			ifTrue:	[1]
			ifFalse: [0].
		messageList := nil].
	^ selectorList! !

!MessageNames methodsFor: 'selector list' stamp: 'sw 7/24/2001 01:55'!
selectorListIndex
	"Answer the selectorListIndex"

	^ selectorListIndex! !

!MessageNames methodsFor: 'selector list' stamp: 'AlainPlantec 11/13/2009 22:59'!
selectorListIndex: anInteger 
	"Set the selectorListIndex as specified, and propagate consequences"

	selectorListIndex := anInteger.
	selectorListIndex = 0
		ifTrue: [^ self].
	messageList := nil.
	self changed: #selectorListIndex.
	self changed: #messageList.
	self changed: #annotation.! !

!MessageNames methodsFor: 'initialization' stamp: 'sw 7/24/2001 01:35'!
selectorListKey: aChar from: view
	"Respond to a Command key in the message-list pane."

	aChar == $n ifTrue: [^ self browseSenders].
	aChar == $c ifTrue: [^ self copyName].
	aChar == $b ifTrue: [^ self browseMethodFull].
! !

!MessageNames methodsFor: 'initialization' stamp: 'tbn 7/29/2010 21:56'!
selectorListMenu: aMenu
	"Answer the menu associated with the selectorList"

	aMenu addList: {
		{'Senders (n)' translated. #browseSenders. 'Browse senders of the chosen selector' translated}.
		{'Copy selector to clipboard' translated. #copyName. 'Copy the chosen selector to the clipboard, for subsequent pasting elsewhere' translated}.
		#-.
		{'Show only implemented selectors' translated. #showOnlyImplementedSelectors. 'Remove from the selector-list all symbols that do not represent implemented methods' translated}}.

	^ aMenu! !

!MessageNames methodsFor: 'selector list' stamp: 'sw 7/24/2001 01:47'!
selectorListMenuTitle
	"Answer the title to supply for the menu belonging to the selector-list pane"

	^ 'Click on any item in the list
to see all implementors of it'! !

!MessageNames methodsFor: 'search' stamp: 'sd 11/20/2005 21:27'!
showOnlyImplementedSelectors
	"Caution -- can be slow!! Filter my selector list down such that it only  
	shows selectors that are actually implemented somewhere in the system."
	self okToChange
		ifTrue: [Cursor wait
				showWhile: [selectorList := self systemNavigation allSelectorsWithAnyImplementorsIn: selectorList.
					self changed: #selectorList.
					self changed: #messageList]]! !

MessageSet subclass: #RecentMessageSet
	instanceVariableNames: ''
	classVariableNames: 'NumberOfRecentSubmissionsToStore RecentSubmissions'
	poolDictionaries: ''
	category: 'Deprecated14'!

!RecentMessageSet commentStamp: 'StephaneDucasse 1/12/2011 17:25' prior: 0!
RecentMessageSet is a message set that shows the most recently-submitted methods, in chronological order.

DEPRECATED use the new RecentMessageList browser.!

!RecentMessageSet class methodsFor: 'utilities' stamp: 'JB 2/19/2010 16:40'!
assureMostRecentSubmissionExists
	"Make certain that the most recent submission exists"

	[RecentSubmissions size > 0 and:
		[RecentSubmissions last isValid not]] whileTrue:
			[RecentSubmissions removeLast].! !

!RecentMessageSet class methodsFor: 'public' stamp: 'StephaneDucasse 2/20/2010 23:36'!
browseRecentSubmissions
	"Open up a browser on the most recent methods submitted in the image.  5/96 sw."
	"RecentMessageSet browseRecentSubmissions"

	| recentMessages |
	self recentMethodSubmissions size isZero ifTrue:
		[^ self inform: 'There are no recent submissions'].
	recentMessages := RecentSubmissions copy reversed.
	self 
		openMessageList: recentMessages 
		name: 'Recent submissions -- youngest first ' 
		autoSelect: nil! !

!RecentMessageSet class methodsFor: 'queries' stamp: 'BenjaminVanRyseghem 1/8/2011 15:37'!
event: anEvent
	"Hook for SystemChangeNotifier"

	^self! !

!RecentMessageSet class methodsFor: 'initialization' stamp: 'StephaneDucasse 2/20/2010 23:39'!
initialize
	
	RecentSubmissions := OrderedCollection new.
	! !

!RecentMessageSet class methodsFor: 'utilities' stamp: 'StephaneDucasse 2/28/2010 11:48'!
mostRecentlySubmittedMessage
	"Answer the most recently submitted method that is still extant"

	self assureMostRecentSubmissionExists.
	(RecentSubmissions isEmpty) ifTrue: [^ nil]
	ifFalse: [^ RecentSubmissions last].! !

!RecentMessageSet class methodsFor: 'utilities' stamp: 'StephaneDucasse 1/7/2011 19:07'!
noteMethodSubmission: selectorName forClass: class

	| submission |
	self recentMethodSubmissions.	"ensure it is valid"
	class wantsChangeSetLogging ifFalse: [^ self].
	self purgeRecentSubmissionsOfMissingMethods.
	submission := class name asString, ' ', selectorName.
	RecentSubmissions removeAllSuchThat: [ :each | each stringVersion = submission ].
	RecentSubmissions size >= self numberOfRecentSubmissionsToStore 
		ifTrue: [RecentSubmissions removeFirst].
	RecentSubmissions addLast: 
		(SourcedMethodReference new
			setClass: class 
			methodSymbol: selectorName 
			stringVersion: submission) 
! !

!RecentMessageSet class methodsFor: 'utilities' stamp: 'StephaneDucasse 2/20/2010 23:38'!
numberOfRecentSubmissionsToStore
	"Answer how many methods back the 'recent method submissions' history should store"

	^ NumberOfRecentSubmissionsToStore ifNil: [NumberOfRecentSubmissionsToStore := 150]! !

!RecentMessageSet class methodsFor: 'utilities' stamp: 'JB 2/19/2010 16:40'!
numberOfRecentSubmissionsToStore: aNumber
	"Set the number of Recent Submissions to store"

	NumberOfRecentSubmissionsToStore := aNumber! !

!RecentMessageSet class methodsFor: 'utilities' stamp: 'StephaneDucasse 8/9/2011 18:06'!
purgeFromRecentSubmissions: aMethodReference
	"Purge any reference found in RecentSubmissions to the method supplied"

	RecentSubmissions := RecentSubmissions select:
		[:aSubmission |
			self setClassAndSelectorFrom: aSubmission in:
				[:aClass :aSelector | (aClass ~~ aMethodReference actualClass) or: [aSelector ~~ aMethodReference selector]]]! !

!RecentMessageSet class methodsFor: 'utilities' stamp: 'MarcusDenker 3/21/2010 20:16'!
purgeRecentSubmissionsOfMissingMethods
	"RecentMessageSet purgeRecentSubmissionsOfMissingMethods"
	
	RecentSubmissions := RecentSubmissions select:
		[:aSubmission | | keep | 
			self setClassAndSelectorFrom: aSubmission in:
				[:aClass :aSelector |
					keep := aClass notNil
						and: [aSelector == #Comment or: [(aClass compiledMethodAt: aSelector ifAbsent: [nil]) notNil]]].
			keep]! !

!RecentMessageSet class methodsFor: 'utilities' stamp: 'JB 2/19/2010 16:39'!
recentMethodSubmissions
	"Answer the list of recent method submissions, in order.  5/16/96 sw"

	RecentSubmissions ifNil: [RecentSubmissions := OrderedCollection new].
	^ RecentSubmissions! !

!RecentMessageSet class methodsFor: 'public' stamp: 'StephaneDucasse 2/20/2010 23:36'!
recentSubmissionsWindow
	"Answer a SystemWindow holding recent submissions"
	"RecentMessageSet recentSubmissionsWindow openInHand"
	
	| recentMessages messageSet |
	recentMessages := RecentSubmissions copy reversed.
	messageSet := self messageList: recentMessages.
	messageSet autoSelectString: nil.
	^ (messageSet inMorphicWindowLabeled: 'Recent submissions -- youngest first') applyModelExtent

	

! !

!RecentMessageSet class methodsFor: 'instance creation' stamp: 'StephaneDucasse 8/9/2011 18:06'!
revertLastMethodSubmission
	| changeRecords lastSubmission theClass theSelector |
	"If the most recent method submission was a method change, revert
	that change, and if it was a submission of a brand-new method, 
	remove that method."

	RecentSubmissions isEmptyOrNil ifTrue: [^ Beeper beep].
	lastSubmission := RecentSubmissions last.
	theClass := lastSubmission actualClass ifNil: [^ Beeper beep].
	theSelector := lastSubmission selector.
	changeRecords := theClass changeRecordsAt: theSelector.
	changeRecords isEmptyOrNil ifTrue: [^ Beeper beep].
	changeRecords size = 1
		ifTrue:
			["method has no prior version, so reverting in this case means removing"
			theClass removeSelector: theSelector]
		ifFalse:
			[changeRecords second fileIn].

"RecentMessageSet revertLastMethodSubmission"! !

!RecentMessageSet class methodsFor: 'utilities' stamp: 'lr 3/14/2010 21:13'!
setClassAndSelectorFrom: messageIDString in: csBlock
	"Decode strings of the form <className> [class] <selectorName>.   If <className> does not exist as a class, use nil for the class in the block"

	| aStream aClass maybeClass sel |
	(messageIDString isKindOf: MethodReference)
		ifTrue: [ ^ messageIDString setClassAndSelectorIn: csBlock ].
	aStream := messageIDString readStream.
	aClass := Smalltalk globals at: (aStream upTo: $ ) asSymbol ifAbsent: [ nil ].
	maybeClass := aStream upTo: $ .
	sel := aStream upTo: $ .
	maybeClass = 'class' & (sel size ~= 0)
		ifTrue: [ aClass ifNil: [ csBlock value: nil value: sel asSymbol ] ifNotNil: [ csBlock value: aClass class value: sel asSymbol ] ]
		ifFalse: [ 
			csBlock value: aClass value: maybeClass asSymbol	"
Utilities setClassAndSelectorFrom: 'Utilities class oppositeModeTo:' in: [:aClass :aSelector | Transcript cr; show: 'Class = ', aClass name printString, ' selector = ', aSelector printString].

Utilities setClassAndSelectorFrom: 'MessageSet setClassAndSelectorIn:' in: [:aClass :aSelector | Transcript cr; show: 'Class = ', aClass name printString, ' selector = ', aSelector printString].
" ]! !

!RecentMessageSet class methodsFor: 'initialization' stamp: 'JB 2/19/2010 16:42'!
startUp
	SystemChangeNotifier uniqueInstance notify: self ofAllSystemChangesUsing: #event:.! !

!RecentMessageSet methodsFor: 'message functions' stamp: 'StephaneDucasse 2/20/2010 23:27'!
addExtraShiftedItemsTo: aMenu
	"The shifted selector-list menu is being built.  Overridden here to defeat the presence of the items that add or change order, since RecentMessageSet defines methods & order explicitly based on external criteria"

	aMenu add: 'Set size of recent history...' action: #setRecentHistorySize! !

!RecentMessageSet methodsFor: 'contents' stamp: 'sd 11/20/2005 21:27'!
contents: c notifying: n
	| result |
	result := super contents: c notifying: n.
	result == true ifTrue:
		[self reformulateList].
	^ result! !

!RecentMessageSet methodsFor: 'update' stamp: 'sw 1/28/2001 20:59'!
growable
	"Answer whether the receiver can be changed by manual additions & deletions"

	^ false! !

!RecentMessageSet methodsFor: 'message functions' stamp: 'tbn 7/6/2010 16:28'!
messageListMenu: aMenu shifted: shifted
	"Answer the message-list menu"

	shifted ifTrue: [^ self shiftedMessageListMenu: aMenu].
	aMenu addList:#(
			('What to show...'						offerWhatToShowMenu)
			-
			('Browse full (b)' 						browseMethodFull)
			('Browse hierarchy (h)'					classHierarchy)
			('Browse method (O)'					openSingleMessageBrowser)
			('Browse protocol (p)'					browseFullProtocol)
			-
			('FileOut (o)'							fileOutMessage)
			('Copy selector (c)'						copySelector)
			-
			('Senders of... (n)'						browseSendersOfMessages)
			('Implementors of... (m)'					browseMessages)
			('Inheritance (i)'						methodHierarchy)
			('Versions (v)'							browseVersions)
			-
			('Inst var refs...'						browseInstVarRefs)
			('Inst var defs...'						browseInstVarDefs)
			('Class var refs...'						browseClassVarRefs)
			('Class variables'						browseClassVariables)
			('Class refs (N)'							browseClassRefs)
			-
			('Remove method (x)'					removeMessage)
			('Remove from RecentSubmissions'		removeFromRecentSubmissions)
			-
			('More...'								shiftedYellowButtonActivity)).
	^ aMenu! !

!RecentMessageSet methodsFor: 'update' stamp: 'StephaneDucasse 2/20/2010 23:34'!
reformulateList
	| myList |
	"Reformulate the receiver's list.  Exclude methods now deleted"
	myList := self class recentMethodSubmissions reversed select: [ :each | each isValid].
	self initializeMessageList: myList.
	self messageListIndex: (messageList size min: messageListIndex).	
	self changed: #messageList.
	self changed: #messageListIndex! !

!RecentMessageSet methodsFor: 'message functions' stamp: 'BenjaminVanRyseghem 11/6/2010 22:27'!
removeFromRecentSubmissions
	"Remove the currently-selected method from the RecentSubmissions list"

	| aClass methodSym |
	((aClass := self selectedClassOrMetaClass) notNil and: [(methodSym := self selectedMessageName) notNil])
		ifTrue: 
			[self class purgeFromRecentSubmissions: (SourcedMethodReference new setClass: aClass methodSymbol: methodSym).
			self reformulateList]! !

!RecentMessageSet methodsFor: 'message list' stamp: 'JB 2/19/2010 18:09'!
setRecentHistorySize
	"Let the user specify the recent history size"

	| aReply aNumber |
	aReply := UIManager default request: 'How many recent methods
should be maintained?' initialAnswer: self class numberOfRecentSubmissionsToStore asString.
	aReply isEmptyOrNil ifFalse:
		[aNumber := aReply asNumber rounded.
		(aNumber > 1 and: [aNumber <= 1000])
			ifTrue:
				[self class numberOfRecentSubmissionsToStore: aNumber.
				self inform: 'Okay, ', aNumber asString, ' is the new size of the recent method history']
			ifFalse:
				[self inform: 'Sorry, must be a number between 2 & 1000']]
			! !

!RecentMessageSet methodsFor: 'update' stamp: 'pavel.krivanek 2/24/2010 14:05'!
updateListsAndCodeIn: aWindow

	| recent |
	
	self canDiscardEdits ifFalse: [^ self].

	recent := self class mostRecentlySubmittedMessage.

	(((messageList isEmpty ) not and: [recent notNil]) and: [messageList first == recent])
		ifFalse:	[self reformulateList]
		ifTrue: [self updateCodePaneIfNeeded]! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:35'!
checkHaltCountExpired

	self deprecated: 'Was used internally by Object>>halt:onCount: See its deprecation warning' on: '8/29/2011' in: '1.4'.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:56'!
clearHaltOnce
	"Turn on image-wide Halt once"

	self deprecated: 'Use "Halt disableHaltOnce". This method bloats Object and wrongly suggests haltOnce may be per-object' on: '8/29/2011' in: '1.4'.
	Halt disableHaltOnce.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:36'!
decrementAndCheckHaltCount

	self deprecated: 'Was used internally by Object>>halt:onCount: See its deprecation warning' on: '8/29/2011' in: '1.4'.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:36'!
decrementHaltCount

	self deprecated: 'Was used internally by Object>>halt:onCount: See its deprecation warning' on: '8/29/2011' in: '1.4'.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:36'!
doExpiredHaltCount

	self deprecated: 'Was used internally by Object>>halt:onCount: See its deprecation warning' on: '8/29/2011' in: '1.4'.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:35'!
doExpiredHaltCount: aString

	self deprecated: 'Was used internally by Object>>halt:onCount: See its deprecation warning' on: '8/29/2011' in: '1.4'.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:57'!
halt: aString 
	
	self deprecated: 'Use #halt. Since you end up in a debugger, aString provides little information' on: '8/29/2011' in: '1.4'.
	Halt signal: aString! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:57'!
halt: aString onCount: anInteger 
	"Deprecated: see below
	Halt on the anInteger-th time through, showing message aString"
		
	| currentCount |
	currentCount := Halt isCounting 
		ifTrue: [ Halt callsUntilHaltOnCount ]
		ifFalse: [
				self deprecated: 'Use #haltOnCount:. Since you end up in a debugger, aString provides little information' on: '8/29/2011' in: '1.4'.
				anInteger ].
	Halt callsUntilHaltOnCount: currentCount - 1.
	Halt callsUntilHaltOnCount = 0 ifTrue: [ Halt now ].! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:36'!
haltCount

	self deprecated: 'Was used internally by Object>>halt:onCount: See its deprecation warning' on: '8/29/2011' in: '1.4'.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:57'!
haltOnce: aString 
	"Halt unless we have already done it once."

	self deprecated: 'Use #haltOnce:. Since you end up in a debugger, aString provides little information' on: '8/29/2011' in: '1.4'.
	Halt isHaltOnceEnabled
		ifTrue: [ Halt disableHaltOnce.
				^ Halt signal: aString ]! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:57'!
haltOnceEnabled
	"is haltOnce enabled globally"

	self deprecated: 'Use "Halt isHaltOnceEnabled".  This method bloats Object and wrongly suggests haltOnce may be per-object' on: '8/29/2011' in: '1.4'.
	^ Halt isHaltOnceEnabled.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 15:51'!
hasHaltCount

	self deprecated: 'Now private to Halt' on: '8/29/2011' in: '1.4'.
	^ Halt isCounting.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 15:51'!
removeHaltCount

	self deprecated: 'Now private to Halt' on: '8/29/2011' in: '1.4'.
	^ Halt stopCounting.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:55'!
setHaltCountTo: int

	self deprecated: 'Was used internally by Object>>halt:onCount: See its deprecation warning' on: '8/29/2011' in: '1.4'.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:58'!
setHaltOnce
	"Turn on the halt once flag."

	self deprecated: 'Use "Halt enableHaltOnce".  This method bloats Object and wrongly suggests haltOnce may be per-object' on: '8/29/2011' in: '1.4'.
	Halt enableHaltOnce.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:34'!
toggleHaltOnce

	self deprecated: 'See Halt for new API' on: '8/29/2011' in: '1.4'.
	Halt isHaltOnceEnabled
		ifTrue: [Halt disableHaltOnce]
		ifFalse: [Halt enableHaltOnce]! !

!ScriptLoader methodsFor: '*deprecated14' stamp: 'AlainPlantec 9/13/2011 21:11'!
removeDejaVuFonts
	"Note, you need to close all windows to make the Deja Vu fonts being GCed"
	"Now that DejaVu is the only font: don't remove it!!"

	true ifTrue: [^self].

	StandardFonts setDefaultFonts: #(
		(defaultFont: 'Accuny' 10)
		(codeFont: 'Accuny' 10)
		(listFont: 'Accuny' 10)
		(menuFont: 'Accuny' 10)
		(windowTitleFont: 'Accuny' 10)
		(balloonFont: 'Accuny' 10)
		(buttonFont: 'Accuny' 10)).
	TextSharedInformation removeKey: 'Bitmap DejaVu Sans'! !

!StrikeFont class methodsFor: '*deprecated14' stamp: 'AlainPlantec 12/18/2009 07:23'!
accunyKey 
	^ #Accuny! !

!StrikeFont class methodsFor: '*deprecated14' stamp: 'HenrikSperreJohansen 1/11/2010 23:23'!
createDejaVu: pointSize
	"Warning: Uses the methods in 'dejaVu font data' category, that will be removed soon (or are already removed) to save space."
	
	| base bold oblique boldOblique point |
	point := pointSize asString.
	base := (StrikeFont new
		buildFromForm: (self perform: ('dejaVuSansBook', point, 'Form') asSymbol)
		data: (self perform: ('dejaVuSansBook', point, 'Data') asSymbol)
		name: 'Bitmap DejaVu Sans ', point)
			pointSize: pointSize.
	bold := (StrikeFont new
		buildFromForm:  (self perform: ('dejaVuSansBold', point, 'Form') asSymbol)
		data: (self perform: ('dejaVuSansBold', point, 'Data') asSymbol)
		name: 'Bitmap DejaVu Sans ', point, 'B')
			emphasis: 1;
			pointSize: pointSize.
	oblique := (StrikeFont new
		buildFromForm: (self perform: ('dejaVuSansOblique', point, 'Form') asSymbol)
		data: (self perform: ('dejaVuSansOblique', point, 'Data') asSymbol)
		name: 'Bitmap DejaVu Sans ', point, 'I')
			emphasis: 2;
			pointSize: pointSize.
	boldOblique := (StrikeFont new
		buildFromForm: (self perform: ('dejaVuSansBoldOblique', point, 'Form') asSymbol)
		data: (self perform: ('dejaVuSansBoldOblique', point, 'Data') asSymbol)
		name: 'Bitmap DejaVu Sans ', point, 'BI')
			emphasis: 3;
			pointSize: pointSize.
		
	base derivativeFont: bold at: 1.
	base derivativeFont: oblique at: 2.
	base derivativeFont: boldOblique at: 3.
	bold derivativeFont: boldOblique at: 2.
	oblique derivativeFont: boldOblique at: 1. 
	
	^base! !

!StrikeFont class methodsFor: '*deprecated14' stamp: 'AlainPlantec 9/12/2011 19:01'!
installDejaVu
	"
	StrikeFont installDejaVu
	"
	StandardFonts restoreDefaultFonts.
	StrikeFont useUnderscoreIfOver1bpp! !
RecentMessageSet initialize!
LogoImageMorph initialize!
